# Lets write something more complex.
# A binary incrementer would look like this:
#
# #! start 0    #! end 3    #! fill *
# 
# 0 0 0 r 0 
# 0 1 1 r 0
# 0 * * l 1
# 
# 1 0 1 l 2
# 1 1 0 l 1
# 1 * 1 n 3
# 
# 2 0 0 l 2
# 2 1 1 l 2
# 2 * * r 3

# As you can see, there are some rules, which look very similar.
# You can use a wildcard to combine them and save time when writing:

#! start 0    #! end 3    #! fill *
#! wildcard ? # define ? as the wildcard

0 * * l 1
0 ? ? r 0 # When something other than * was read, write it again and move right

1 0 1 l 2
1 1 0 l 1
1 * 1 n 3

2 * * r 3
2 ? ? l 2 # When something other than * was read, write it again and move right

# When used in 'read', the wildcard stands for all symbols that aren't part of
# a rule with the same state.
# When used in 'write', it's just the symbol, that was read.
#
# If the wildcard symbol is used for other things than 'read' or 'write'
# it looses its meaning and is treated as a every other symbol.

